/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-11 at 00:22:18 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.bigquery.model;

/**
 * Model definition for JobStatistics.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the BigQuery API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class JobStatistics extends com.google.api.client.json.GenericJson {

  /**
   * [Output-only] End time of this job, in milliseconds since the epoch.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long endTime;

  /**
   * [Output-only] Statistics for a load job.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private JobStatistics3 load;

  /**
   * [Output-only] Statistics for a query job.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private JobStatistics2 query;

  /**
   * [Output-only] Start time of this job, in milliseconds since the epoch.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long startTime;

  /**
   * [Output-only] [Deprecated] Use the bytes processed in the query statistics instead.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long totalBytesProcessed;

  /**
   * [Output-only] End time of this job, in milliseconds since the epoch.
   * @return value or {@code null} for none
   */
  public java.lang.Long getEndTime() {
    return endTime;
  }

  /**
   * [Output-only] End time of this job, in milliseconds since the epoch.
   * @param endTime endTime or {@code null} for none
   */
  public JobStatistics setEndTime(java.lang.Long endTime) {
    this.endTime = endTime;
    return this;
  }

  /**
   * [Output-only] Statistics for a load job.
   * @return value or {@code null} for none
   */
  public JobStatistics3 getLoad() {
    return load;
  }

  /**
   * [Output-only] Statistics for a load job.
   * @param load load or {@code null} for none
   */
  public JobStatistics setLoad(JobStatistics3 load) {
    this.load = load;
    return this;
  }

  /**
   * [Output-only] Statistics for a query job.
   * @return value or {@code null} for none
   */
  public JobStatistics2 getQuery() {
    return query;
  }

  /**
   * [Output-only] Statistics for a query job.
   * @param query query or {@code null} for none
   */
  public JobStatistics setQuery(JobStatistics2 query) {
    this.query = query;
    return this;
  }

  /**
   * [Output-only] Start time of this job, in milliseconds since the epoch.
   * @return value or {@code null} for none
   */
  public java.lang.Long getStartTime() {
    return startTime;
  }

  /**
   * [Output-only] Start time of this job, in milliseconds since the epoch.
   * @param startTime startTime or {@code null} for none
   */
  public JobStatistics setStartTime(java.lang.Long startTime) {
    this.startTime = startTime;
    return this;
  }

  /**
   * [Output-only] [Deprecated] Use the bytes processed in the query statistics instead.
   * @return value or {@code null} for none
   */
  public java.lang.Long getTotalBytesProcessed() {
    return totalBytesProcessed;
  }

  /**
   * [Output-only] [Deprecated] Use the bytes processed in the query statistics instead.
   * @param totalBytesProcessed totalBytesProcessed or {@code null} for none
   */
  public JobStatistics setTotalBytesProcessed(java.lang.Long totalBytesProcessed) {
    this.totalBytesProcessed = totalBytesProcessed;
    return this;
  }

  @Override
  public JobStatistics set(String fieldName, Object value) {
    return (JobStatistics) super.set(fieldName, value);
  }

  @Override
  public JobStatistics clone() {
    return (JobStatistics) super.clone();
  }

}
